-- Flame
-- Battlemod Compass by CobaltBW

rawset(_G, "KOTH_findFlag", function(mty)
	if not (maptol & TOL_KOTH) then return end -- Nice try silly...
	if not mty then mty = "MT_KOTHFLAG" end

	local mo
	for m in mobjs.iterate() do
		if mty and (m.type ~= mty) then continue end -- If we have an mtype, search for it!
		if (m.health <= 0) then continue end -- Dead
		mo = m
		break -- Only care about the first one found.
	end
	
	return mo
end)

hud.add(function(v, p, c)
	--if not v or not v.valid then return end
	--if not p or not p.valid then return end
	--if not c or not c.valid then return end
	if not (maptol & TOL_KOTH) then return end -- Nice try silly...
	
	local mo = p.mo or p.realmo
	
	local flags = V_HUDTRANS|V_SNAPTOTOP|V_PERPLAYER
	local xoffset, yoffset = 152 ,4
	local angle, cmpangle, compass, color
	local pcol = p.skincolor
	local flagmo = KOTH_findFlag(MT_KOTHFLAG)
	if mo and mo.valid and flagmo and flagmo.valid
		-- Use the angle based off x and z rather than x and y
		if twodlevel then
			angle = R_PointToAngle2(mo.x, mo.z, flagmo.x, flagmo.z) - ANGLE_90
		else
			angle = R_PointToAngle2(mo.x,mo.y,flagmo.x,flagmo.y) - p.cmd.angleturn<<16
		end
		cmpangle = ((-angle)/ANG1)/(360/9)+5
		compass = v.getSpritePatch("CMPS",A,max(min(cmpangle,8),1))
		color = v.getColormap(TC_DEFAULT,pcol)
		//Draw
		v.draw(xoffset,yoffset,compass,flags,color)
	end
end, "game")